/**
 * {}
 * @author yutent<yutent.io@gmail.com>
 * @date 2023/09/04 19:18:28
 */

import { nextTick } from 'wkit'

export function noop() {}

export function getContainers(all = true) {
  return native.handler('docker', { action: 'containers', all })
}

export function getImages() {
  return native.handler('docker', { action: 'images' })
}

export function removeContainer(id) {
  return native.handler('docker', { action: 'rm', id })
}

export function removeImage(id) {
  return native.handler('docker', { action: 'rmi', id })
}
